﻿using Infragistics.Controls.Editors;
using Infragistics.Windows.Controls;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XPGFilterProperties
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            ObservableCollection<Person> People = new ObservableCollection<Person> { new Person(), new Person()};
            this.DataContext = People;

            User currentUser = new User();
            this.userTypeTB.Text = "Current user's type is: " + currentUser.UserType.ToString();

            ModifyShownProperties(currentUser.UserType);
        }

        private void userBtn_Click(object sender, RoutedEventArgs e)
        {
            User currentUser = new User();
            this.userTypeTB.Text = "Current user's type is: " + currentUser.UserType.ToString();

            ModifyShownProperties(currentUser.UserType);
        }

        private void ModifyShownProperties(UserTypeEnum userType)
        {
            PropertyGridConditionGroup filterConditions = new PropertyGridConditionGroup();
            filterConditions.LogicalOperator = LogicalOperator.Or;

            switch (userType)
            {
                case UserTypeEnum.Dummy:

                    PropertyGridComparisonCondition comparisonCondition1 = new PropertyGridComparisonCondition();
                    comparisonCondition1.OperandSource = PropertyGridFilterOperandSource.CategoryName;
                    comparisonCondition1.Operator = ComparisonOperator.Equals;
                    comparisonCondition1.Value = "Occupation";

                    PropertyGridComparisonCondition comparisonCondition2 = new PropertyGridComparisonCondition();
                    comparisonCondition2.OperandSource = PropertyGridFilterOperandSource.CategoryName;
                    comparisonCondition2.Operator = ComparisonOperator.Equals;
                    comparisonCondition2.Value = "Location";

                    filterConditions.Clear();
                    filterConditions.Add(comparisonCondition1);
                    filterConditions.Add(comparisonCondition2);
                    this.xamPropertyGrid1.ItemFilters = filterConditions;

                    break;
                case UserTypeEnum.Normal:
                   
                    PropertyGridComparisonCondition comparisonCondition3 = new PropertyGridComparisonCondition();
                    comparisonCondition3.OperandSource = PropertyGridFilterOperandSource.CategoryName;
                    comparisonCondition3.Operator = ComparisonOperator.Equals;
                    comparisonCondition3.Value = "Occupation";

                    PropertyGridComparisonCondition comparisonCondition4 = new PropertyGridComparisonCondition();
                    comparisonCondition4.OperandSource = PropertyGridFilterOperandSource.CategoryName;
                    comparisonCondition4.Operator = ComparisonOperator.Equals;
                    comparisonCondition4.Value = "Location";

                    PropertyGridComparisonCondition comparisonCondition5 = new PropertyGridComparisonCondition();
                    comparisonCondition5.OperandSource = PropertyGridFilterOperandSource.CategoryName;
                    comparisonCondition5.Operator = ComparisonOperator.Equals;
                    comparisonCondition5.Value = "Identification";

                    filterConditions.Clear();

                    filterConditions.Add(comparisonCondition3);
                    filterConditions.Add(comparisonCondition4);
                    filterConditions.Add(comparisonCondition5);

                    this.xamPropertyGrid1.ItemFilters = filterConditions;

                    break;

                case UserTypeEnum.Expert:
                default:
                    filterConditions.Clear();
                    this.xamPropertyGrid1.ItemFilters = null;

                    break;
            }
        }

        private void ListBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            ListBox lb = (ListBox)sender;
            object[] objs = new object[lb.SelectedItems.Count];
            lb.SelectedItems.CopyTo(objs, 0);
            this.xamPropertyGrid1.SelectedObjects = objs;
        }
    }
}
