﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XPGFilterProperties
{
    public class Person
    {
        private static int _idCounter;

        [Category("Identification")]
        public int ID { get; set; }

        [Category("Personal Info")]
        public string FirstName { get; set; }
        [Category("Personal Info")]
        public string LastName { get; set; }
        [Category("Personal Info")]
        public int Age { get; set; }
        [Category("Personal Info")]
        public List<Child> Children { get; set; }

        [Category("Location")]
        public string City { get; set; }

        [Category("Location")]
        [DefaultValue("Bulgaria")]
        public string Country { get; set; }

        [Category("Occupation")]
        public Job Job { get; set; }

        public Person()
        {
            this.ID = ++_idCounter;
            this.FirstName = "Person";
            this.LastName = "Persons " + _idCounter;
            this.Age = _idCounter;
            this.Children = new List<Child> { new Child() };
            this.City = "Sofia";
            this.Job = new Job("Infragistics", "Developer support");
        }

        public override string ToString()
        {
            return this.FirstName + " " + this.LastName;
        }
    }

    public class Job
    {
        public string Company { get; set; }
        public string JobTitle { get; set; }

        public Job(string c, string t)
        {
            Company = c;
            JobTitle = t;
        }
    }

    public class Child
    {
        public string Name { get; set; }

        public Child()
        {
            Name = "ChildName";
        }
    }
}
